<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.15" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__gattdb__api__functions" kind="group">
    <compoundname>gattdb_api_functions</compoundname>
    <title>GATT Database</title>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__gattdb__api__functions_1ga29fd2f86442a2fdadf9c4a05094e5c7f" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__wicedbt__gatt_1gaf2fed4c3092ffd14ce4f213a60c02fe4">wiced_bt_gatt_status_t</ref></type>
        <definition>wiced_bt_gatt_status_t wiced_bt_gatt_db_init</definition>
        <argsstring>(const uint8_t *p_gatt_db, uint16_t gatt_db_size, wiced_bt_db_hash_t hash)</argsstring>
        <name>wiced_bt_gatt_db_init</name>
        <param>
          <type>const uint8_t *</type>
          <declname>p_gatt_db</declname>
        </param>
        <param>
          <type>uint16_t</type>
          <declname>gatt_db_size</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__bt__types_1ga6b2f6680ad9b818353df2c23bcd96546">wiced_bt_db_hash_t</ref></type>
          <declname>hash</declname>
        </param>
        <briefdescription>
<para>Initialize the GATT database (Please refer <ref kindref="member" refid="group__wicedbt__gatt_1GATT_DB_MACROS">Service and Characteristic macros</ref> for MACRO's to create or add entries to GATT database) </para>
        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">p_gatt_db</parametername>
</parameternamelist>
<parameterdescription>
<para>: First element in GATT database array </para>
</parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">gatt_db_size</parametername>
</parameternamelist>
<parameterdescription>
<para>: Size (in bytes) of GATT database </para>
</parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="out">hash</parametername>
</parameternamelist>
<parameterdescription>
<para>: The calculated database hash value. The hash pointer passed to this function can be NULL incase the application does not support dynamic databases and does not support database caching</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para><ref kindref="member" refid="group__wicedbt__gatt_1ga972f2437538363989cee28019cb06652">wiced_bt_gatt_status_t </ref> </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_bt_gatt.h" line="966" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__gattdb__api__functions_1ga677cb480a1affb01d8f2c7f4c35dff2e" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__wicedbt__gatt_1gaf2fed4c3092ffd14ce4f213a60c02fe4">wiced_bt_gatt_status_t</ref></type>
        <definition>wiced_bt_gatt_status_t wiced_bt_gatt_add_services_to_db</definition>
        <argsstring>(const uint8_t *p_gatt_db, uint16_t gatt_db_size, wiced_bt_db_hash_t hash)</argsstring>
        <name>wiced_bt_gatt_add_services_to_db</name>
        <param>
          <type>const uint8_t *</type>
          <declname>p_gatt_db</declname>
        </param>
        <param>
          <type>uint16_t</type>
          <declname>gatt_db_size</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__bt__types_1ga6b2f6680ad9b818353df2c23bcd96546">wiced_bt_db_hash_t</ref></type>
          <declname>hash</declname>
        </param>
        <briefdescription>
<para>Add a service module to the database. </para>
        </briefdescription>
        <detaileddescription>
<para>Service modules define the complete service handles The handle range in the service modules have to be distinct, i.e, cannot overlap with any of the existing service modules in the database</para>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">p_gatt_db</parametername>
</parameternamelist>
<parameterdescription>
<para>: First element in GATT database array </para>
</parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">gatt_db_size</parametername>
</parameternamelist>
<parameterdescription>
<para>: Size (in bytes) of GATT database </para>
</parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="out">hash</parametername>
</parameternamelist>
<parameterdescription>
<para>: The calculated database hash value. The hash pointer passed to this function can be NULL incase the application does not support dynamic databases and does not support database caching</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para><ref kindref="member" refid="group__wicedbt__gatt_1ga972f2437538363989cee28019cb06652">wiced_bt_gatt_status_t </ref> </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_bt_gatt.h" line="982" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__gattdb__api__functions_1ga6183e7711927516a6dc3dcaee3d85241" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__wicedbt__gatt_1gaf2fed4c3092ffd14ce4f213a60c02fe4">wiced_bt_gatt_status_t</ref></type>
        <definition>wiced_bt_gatt_status_t wiced_bt_gatt_db_remove_services_from_db</definition>
        <argsstring>(const uint8_t *p_gatt_db, wiced_bt_db_hash_t hash)</argsstring>
        <name>wiced_bt_gatt_db_remove_services_from_db</name>
        <param>
          <type>const uint8_t *</type>
          <declname>p_gatt_db</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__bt__types_1ga6b2f6680ad9b818353df2c23bcd96546">wiced_bt_db_hash_t</ref></type>
          <declname>hash</declname>
        </param>
        <briefdescription>
<para>Remove the service module from the database. </para>
        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">p_gatt_db</parametername>
</parameternamelist>
<parameterdescription>
<para>: First element in GATT database array </para>
</parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="out">hash</parametername>
</parameternamelist>
<parameterdescription>
<para>: The calculated database hash value. The hash pointer passed to this function can be NULL incase the application does not support dynamic databases and does not support database caching</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para><ref kindref="member" refid="group__wicedbt__gatt_1ga972f2437538363989cee28019cb06652">wiced_bt_gatt_status_t </ref> </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_bt_gatt.h" line="994" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__gattdb__api__functions_1ga66c9d67c8068bfe3a82a74fe2fcbda5d" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="compound" refid="structwiced__gattdb__entry__t">wiced_gattdb_entry_t</ref> *</type>
        <definition>wiced_gattdb_entry_t* wiced_bt_gattdb_next_entry</definition>
        <argsstring>(wiced_gattdb_entry_t *p_db_entry)</argsstring>
        <name>wiced_bt_gattdb_next_entry</name>
        <param>
          <type><ref kindref="compound" refid="structwiced__gattdb__entry__t">wiced_gattdb_entry_t</ref> *</type>
          <declname>p_db_entry</declname>
        </param>
        <briefdescription>
<para>Find the next GATT attribute entry in the local GATT database To find the first attribute entry pass the address of the local GATT database as a parameter. </para>
        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">p_db_entry</parametername>
</parameternamelist>
<parameterdescription>
<para>: GATT DB attribute entry</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>pointer to next attribute entry </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_bt_gatt.h" line="1005" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__gattdb__api__functions_1gabba2ffae8e57ab3035d2fa2b8b167223" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>uint16_t</type>
        <definition>uint16_t wiced_bt_gattdb_get_handle</definition>
        <argsstring>(wiced_gattdb_entry_t *p_db_entry)</argsstring>
        <name>wiced_bt_gattdb_get_handle</name>
        <param>
          <type><ref kindref="compound" refid="structwiced__gattdb__entry__t">wiced_gattdb_entry_t</ref> *</type>
          <declname>p_db_entry</declname>
        </param>
        <briefdescription>
<para>Utility to get attribute handle from GATT DB entry To get next attribute handle, application needs traverse by wiced_bt_gattdb_next_entry. </para>
        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">p_db_entry</parametername>
</parameternamelist>
<parameterdescription>
<para>: GATT DB attribute entry</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>attribute handle </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_bt_gatt.h" line="1016" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__gattdb__api__functions_1ga34186004426c5027e17ee9e33ac2591e" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>uint32_t</type>
        <definition>uint32_t wiced_bt_gattdb_get_attribute_uuid</definition>
        <argsstring>(wiced_gattdb_entry_t *p_db_entry, uint8_t *p_uuid)</argsstring>
        <name>wiced_bt_gattdb_get_attribute_uuid</name>
        <param>
          <type><ref kindref="compound" refid="structwiced__gattdb__entry__t">wiced_gattdb_entry_t</ref> *</type>
          <declname>p_db_entry</declname>
        </param>
        <param>
          <type>uint8_t *</type>
          <declname>p_uuid</declname>
        </param>
        <briefdescription>
<para>Utility to get the attribute UUID for the given database entry. </para>
        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">p_db_entry</parametername>
</parameternamelist>
<parameterdescription>
<para>: GATT DB attribute entry </para>
</parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="out">p_uuid</parametername>
</parameternamelist>
<parameterdescription>
<para>: pointer to UUID holder. Application should pass the required size of UUID. It is recommended to pass uint8_t[16], so that we can avoid overflow in case of 128 bit uuid</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>size of the UUID </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_bt_gatt.h" line="1028" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__gattdb__api__functions_1ga11e5889a5c9a918bb8852527f41d1012" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>uint16_t</type>
        <definition>uint16_t wiced_bt_gattdb_get_attribute_value_uuid16</definition>
        <argsstring>(wiced_gattdb_entry_t *p_db_entry)</argsstring>
        <name>wiced_bt_gattdb_get_attribute_value_uuid16</name>
        <param>
          <type><ref kindref="compound" refid="structwiced__gattdb__entry__t">wiced_gattdb_entry_t</ref> *</type>
          <declname>p_db_entry</declname>
        </param>
        <briefdescription>
<para>Utility to get service UUID from GATTDB Primary/Secondary services. </para>
        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">p_db_entry</parametername>
</parameternamelist>
<parameterdescription>
<para>: GATT DB attribute entry</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>16 bit uuid </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_bt_gatt.h" line="1038" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__gattdb__api__functions_1gab67ee0bb9c35b004296031b7edb0209d" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>uint16_t</type>
        <definition>uint16_t wiced_bt_gattdb_get_charcteristic_descriptor_handle</definition>
        <argsstring>(uint16_t char_handle, uint16_t descriptor_uuid)</argsstring>
        <name>wiced_bt_gattdb_get_charcteristic_descriptor_handle</name>
        <param>
          <type>uint16_t</type>
          <declname>char_handle</declname>
        </param>
        <param>
          <type>uint16_t</type>
          <declname>descriptor_uuid</declname>
        </param>
        <briefdescription>
<para>Utility to get characteristic descriptor handle value from GATTDB. </para>
        </briefdescription>
        <detaileddescription>
<para>If characteristic does not have a characteristic descriptor with specified UUID, function will return zero</para>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">char_handle</parametername>
</parameternamelist>
<parameterdescription>
<para>: GATT DB characteristic handle </para>
</parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">descriptor_uuid</parametername>
</parameternamelist>
<parameterdescription>
<para>: Characteristic descriptor UUID</para>
</parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>characteristic descriptor handle </para>
</simplesect>
</para>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="C:/r1/builds/45XoCijv/0/repo/btstack/wiced_include/wiced_bt_gatt.h" line="1050" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para>GATT Database Access Functions. </para>
    </briefdescription>
    <detaileddescription>
    </detaileddescription>
  </compounddef>
</doxygen>